Question Answering Projects - Update Sources
Updates the sources of a project.
PATCH {Endpoint}/language/authoring/query-knowledgebases/projects/{projectName}/sources?api-version=2023-04-01
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
Endpoint
|
path | True |
string (uri) |
Supported Cognitive Services endpoint (e.g., https://<resource-name>.api.cognitiveservices.azure.com). |
|
project
|
path | True |
string maxLength: 100pattern: ^(?=[a-zA-Z0-9])[a-zA-Z0-9-]{0,98}[a-zA-Z0-9]$ |
The name of the project to use. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
Request Body
| Name | Type | Description |
|---|---|---|
| body |
Update sources parameters of a project. |
Responses
| Name | Type | Description |
|---|---|---|
| 202 Accepted |
The request has been accepted for processing, but processing has not yet completed. Headers Operation-Location: string |
|
| Other Status Codes |
An unexpected error response. Headers x-ms-error-code: string |
Security
Ocp-Apim-Subscription-Key
Type:
apiKey
In:
header
OAuth2Auth
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| https://cognitiveservices.azure.com/.default |
Examples
Successful query
Sample request
PATCH {Endpoint}/language/authoring/query-knowledgebases/projects/proj1/sources?api-version=2023-04-01
[
{
"op": "add",
"value": {
"displayName": "source3",
"source": "https://docs.microsoft.com/en-us/azure/cognitive-services/cognitive-services-support-options?context=/azure/cognitive-services/qnamaker/context/context",
"sourceKind": "url",
"sourceUri": "https://docs.microsoft.com/en-us/azure/cognitive-services/cognitive-services-support-options?context=/azure/cognitive-services/qnamaker/context/context"
}
},
{
"op": "replace",
"value": {
"displayName": "source1",
"refresh": true,
"source": "https://docs.microsoft.com/en-us/azure/cognitive-services/qnamaker/overview/overview",
"sourceKind": "url",
"sourceUri": "https://docs.microsoft.com/en-us/azure/cognitive-services/qnamaker/overview/overview"
}
},
{
"op": "delete",
"value": {
"displayName": "source2",
"source": "surface-guide.pdf",
"sourceKind": "file",
"sourceUri": "https://download.microsoft.com/download/2/9/B/29B20383-302C-4517-A006-B0186F04BE28/surface-pro-4-user-guide-EN.pdf"
}
}
]
Sample response
Operation-Location: https:///language/authoring/query-knowledgebases/projects/proj1/sources/jobs/job1?api-version=2023-04-01
Definitions
| Name | Description |
|---|---|
| Error |
The error object. |
|
Error |
Human-readable error code. |
|
Error |
Error response. |
|
Inner |
Human-readable error code. |
|
Inner |
An object containing more specific information about the error. As per Microsoft One API guidelines - https://github.com/Microsoft/api-guidelines/blob/vNext/Guidelines.md#7102-error-condition-responses. |
|
source |
Content structure type for sources. |
|
source |
Supported source types. |
|
update |
Update operation type for assets. |
|
Update |
Update source record. |
|
Update |
Source to be updated. |
Error
The error object.
| Name | Type | Description |
|---|---|---|
| code |
One of a server-defined set of error codes. |
|
| details |
Error[] |
An array of details about specific errors that led to this reported error. |
| innererror |
An object containing more specific information than the current object about the error. |
|
| message |
string |
A human-readable representation of the error. |
| target |
string |
The target of the error. |
ErrorCode
Human-readable error code.
| Value | Description |
|---|---|
| InvalidRequest |
Invalid request error |
| InvalidArgument |
Invalid argument error |
| Unauthorized |
Unauthorized access error |
| Forbidden |
Forbidden access error |
| NotFound |
Not found error |
| ProjectNotFound |
Project not found error |
| OperationNotFound |
Operation not found error |
| AzureCognitiveSearchNotFound |
Azure Cognitive Search not found error |
| AzureCognitiveSearchIndexNotFound |
Azure Cognitive Search index not found error |
| TooManyRequests |
Too many requests error |
| AzureCognitiveSearchThrottling |
Azure Cognitive Search throttling error |
| AzureCognitiveSearchIndexLimitReached |
Azure Cognitive Search index limit reached error |
| InternalServerError |
Internal server error |
| ServiceUnavailable |
Service unavailable error |
| Timeout |
Timeout error |
| QuotaExceeded |
Quota exceeded error |
| Conflict |
Conflict error |
| Warning |
Warning error |
ErrorResponse
Error response.
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
InnerErrorCode
Human-readable error code.
| Value | Description |
|---|---|
| InvalidRequest |
Invalid request error |
| InvalidParameterValue |
Invalid parameter value error |
| KnowledgeBaseNotFound |
Knowledge base not found error |
| AzureCognitiveSearchNotFound |
Azure Cognitive Search not found error |
| AzureCognitiveSearchThrottling |
Azure Cognitive Search throttling error |
| ExtractionFailure |
Extraction failure error |
| InvalidRequestBodyFormat |
Invalid request body format error |
| EmptyRequest |
Empty request error |
| MissingInputDocuments |
Missing input documents error |
| InvalidDocument |
Invalid document error |
| ModelVersionIncorrect |
Model version incorrect error |
| InvalidDocumentBatch |
Invalid document batch error |
| UnsupportedLanguageCode |
Unsupported language code error |
| InvalidCountryHint |
Invalid country hint error |
InnerErrorModel
An object containing more specific information about the error. As per Microsoft One API guidelines - https://github.com/Microsoft/api-guidelines/blob/vNext/Guidelines.md#7102-error-condition-responses.
| Name | Type | Description |
|---|---|---|
| code |
One of a server-defined set of error codes. |
|
| details |
object |
Error details. |
| innererror |
An object containing more specific information than the current object about the error. |
|
| message |
string |
Error message. |
| target |
string |
Error target. |
sourceContentStructureKind
Content structure type for sources.
| Value | Description |
|---|---|
| unstructured |
Unstructured. |
sourceKind
Supported source types.
| Value | Description |
|---|---|
| file |
File Source. |
| url |
URI Source. |
updateOperationKind
Update operation type for assets.
| Value | Description |
|---|---|
| add |
Add operation. |
| delete |
Delete operation. |
| replace |
Replace operation. |
UpdateQnaSourceRecord
Update source record.
| Name | Type | Default value | Description |
|---|---|---|---|
| contentStructureKind | unstructured |
Content structure type for sources. |
|
| displayName |
string minLength: 1maxLength: 200 |
Friendly name of the Source. |
|
| refresh |
boolean |
Boolean flag used to refresh data from the Source. |
|
| source |
string |
Unique source identifier. Name of the file if it's a 'file' source; otherwise, the complete URL if it's a 'url' source. |
|
| sourceKind |
Supported source types. |
||
| sourceUri |
string (uri) |
URI location for the file or url. |
UpdateSourceRecord
Source to be updated.
| Name | Type | Description |
|---|---|---|
| op |
Update operation type for assets. |
|
| value |
Update source record. |